## aqsis 1.6.0

=== CMakeLists.txt ===
project(aqsis_all)

cmake_minimum_required(VERSION 2.6.3)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

# Disallow in-source build
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" aqsis_in_source)
if(aqsis_in_source)
	message(FATAL_ERROR "Aqsis requires an out of source build. Please create a separate build directory and run 'cmake path_to_source [options]' there.")
endif()


# Path to aqsis-specific include directories for cmake helper scripts.
set(CMAKE_MODULE_PATH
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules"
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Include some helper scripts and macros.
include(UtilMacros)
include(AqsisTesting)
include(FirstCMakeRun)
include(XslTransform)

#-------------------------------------------------------------------------------
# Build-time options which can be set from ccmake or the command line
#--------------------------------------------------------------------

option(AQSIS_USE_TIMERS "Enable performance timers" ON)
option(AQSIS_USE_PDIFF "Build the external pdiff perceptual image difference utility" OFF)
option(AQSIS_USE_FLTK "Build the aqsis GUI components which rely on the fltk library" ON)
option(AQSIS_USE_OPENEXR "Build aqsis with support for the OpenEXR image format" ON)
option(AQSIS_USE_EXTERNAL_TINYXML "Try to find and use an external tinyxml library" OFF)
mark_as_advanced(AQSIS_USE_PDIFF AQSIS_USE_EXTERNAL_TINYXML)

option(aqsis_enable_testing "Enable unit testing" OFF)
option(AQSIS_ENABLE_MPDUMP "Enable micropolygon dumping code" OFF)
option(AQSIS_ENABLE_MASSIVE "Enable Massive support" ON)
option(AQSIS_ENABLE_SIMBIONT "Enable Simbiont(RM) support" ON)
option(AQSIS_ENABLE_THREADING "Enable multi-threading (EXPERIMENTAL)" OFF)
option(AQSIS_ENABLE_DEVDOCS "Enable developer documentation" OFF)
mark_as_advanced(AQSIS_ENABLE_MPDUMP AQSIS_ENABLE_MASSIVE AQSIS_ENABLE_SIMBIONT
	AQSIS_ENABLE_DEVDOCS)

option(AQSIS_USE_RPATH "Enable runtime path for installed libs" ON)
mark_as_advanced(AQSIS_USE_RPATH)

if(WIN32)
	# Find path to precompiled libs on windows.
	set(AQSIS_WIN32LIBS "" CACHE PATH "The location of the win32libs SVN folder")
endif()

set(AQSIS_MAIN_CONFIG_NAME "aqsisrc"
	CACHE STRING "Name of the main aqsis configuration file")
mark_as_advanced(AQSIS_MAIN_CONFIG_NAME)


#-------------------------------------------------------------------------------
# Find necessary library dependencies.
#-------------------------------------

# Required libs
# -------------
find_package(TIFF)
find_package(ZLIB)

# Find boost.
set(BOOST_ROOT "$ENV{BOOST_ROOT}" CACHE PATH "Root location of the Boost install")
if(WIN32)
	set(Boost_USE_STATIC_LIBS ON)
endif()
set(Boost_ADDITIONAL_VERSIONS "1.40.0" "1.40" "1.39.0" "1.39" "1.38.0" "1.38" "1.37.0" "1.37")
find_package(Boost 1.34.1)
# The following is a workaround because Boost versions > 1.35.0 need the
# system library. CMake versions >2.6.4 should fix this properly.
set(local_boost_version "${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}")
if(local_boost_version VERSION_LESS "1.35")
    find_package(Boost 1.34.1
		COMPONENTS filesystem iostreams wave unit_test_framework thread regex)
else()
    find_package(Boost 1.34.1
		COMPONENTS filesystem iostreams wave unit_test_framework thread regex system)
endif()

link_directories(${Boost_LIBRARY_DIRS})


# Optional libs
# -------------

# FLTK
if(AQSIS_USE_FLTK)
	find_package(FLTK)

	if(NOT AQSIS_FLTK_FOUND)
		message("** FLTK not found - building without eqsl, piqsl and legacy framebuffer")
		set(AQSIS_USE_FLTK OFF)
	endif()

	if(NOT AQSIS_FLUID_FOUND)
		message("** fluid not found - building without eqsl and piqsl")
	endif()
endif()

# OpenEXR
if(AQSIS_USE_OPENEXR)
	find_package(OpenEXR)

	if(NOT AQSIS_OPENEXR_FOUND)
		message("** Cannot find OpenEXR - aqsis will be build without support for the OpenEXR image format")
		set(AQSIS_USE_OPENEXR OFF)
	endif()
endif()


## find tinyxml.  If not found we use the version distributed with the aqsis
## source.
#if(AQSIS_USE_EXTERNAL_TINYXML)
#	find_package(TinyXML)
#	if(NOT TINYXML_FOUND)
#		message("** Cannot find external tinyxml library - using version included with the aqsis source.")
#		set(AQSIS_USE_EXTERNAL_TINYXML OFF)
#	endif()
#endif()


#-------------------------------------------------------------------------------
# Find build tools
#-----------------

include(FindXsltproc)
if(NOT AQSIS_XSLTPROC_EXECUTABLE_FOUND)
	message(FATAL_ERROR "Aqsis requires xsltproc to build")
endif()

include(FindFlexBison)

if(NOT AQSIS_FLEX_EXECUTABLE_FOUND)
	message(FATAL_ERROR "Aqsis requires flex to build")
endif()
if(NOT AQSIS_BISON_EXECUTABLE_FOUND)
	message(FATAL_ERROR "Aqsis requires bison to build")
endif()

# Windows-specific build tools:
include(FindNSIS)
# Apple-specific build tools:
include(FindOsacompile)
include(FindXcodebuild)
include(FindResource)

#-------------------------------------------------------------------------------
# Set program version numbers
#----------------------------

# These are needed by version.h, as well as the packaging stuff.  Note that
# some packaging variables are set in the platform-specific config files, and
# these version variables are potentially used there.
set(VERSION_MAJOR 1)
set(VERSION_MINOR 6)
set(VERSION_BUILD 0)
set(SCM_REVISION 0) # "?"


#-------------------------------------------------------------------------------
# Set variables which control the build
#--------------------------------------

# Set convenience locations into which libraries and executables will be
# placed during the build.  Note: This is irrelevant to the install.
set(RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
#set(ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)


# Set default build type the first time cmake is run, but only if it's empty
# since an alternative value might have been specified on the command line,
# and we want this to override the default given below.
#
# We need to jump through some hoops here with the set_if_empty() macro, since
# CMAKE_BUILD_TYPE is a system-defined variable which means we can't get to it
# with set() before it's defined.
if(FIRST_CMAKE_RUN)
	set_if_empty(CMAKE_BUILD_TYPE "Release" CACHE STRING
		"Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
		FORCE
		)
endif()

# Set up the install rpath if desired.
set(CMAKE_SKIP_RPATH OFF CACHE INTERNAL
	"Disabled, since we need RPATHS to find aqsl during the build" FORCE)
if(AQSIS_USE_RPATH)
	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIBDIR}")
endif()


#-------------------------------------------------------------------------------
# System-specific includes
#-------------------------

# Include setup for system-specific paths, packaging etc
if(WIN32)
	include(${CMAKE_SOURCE_DIR}/cmake/platform/windows.cmake)
	# Build the .rc files for library and executable version information and icons.
	set(INFORES_SRCS "${PROJECT_BINARY_DIR}/info.rc")
	set(ICONRES_SRCS "${PROJECT_BINARY_DIR}/icon.rc")
	configure_file("${CMAKE_SOURCE_DIR}/distribution/win/info.rc.in.cmake" ${INFORES_SRCS})
	configure_file("${CMAKE_SOURCE_DIR}/distribution/win/icon.rc.in.cmake" ${ICONRES_SRCS})
elseif(APPLE)
	include(${CMAKE_SOURCE_DIR}/cmake/platform/macosx.cmake)
else()
	include(${CMAKE_SOURCE_DIR}/cmake/platform/linux.cmake) 
endif()


#-------------------------------------------------------------------------------
# Add directories for all subprojects
#------------------------------------
add_subdirectory(include/aqsis)
include_directories(
	"${PROJECT_SOURCE_DIR}/include"
	"${PROJECT_BINARY_DIR}/include"
	${Boost_INCLUDE_DIRS}
)

# Thirdparty libs
declare_subproject(thirdparty/tinyxml)
if(AQSIS_USE_PDIFF)
  add_subdirectory(thirdparty/pdiff)
endif()

# Build libraries
add_subdirectory(libs/math)
add_subdirectory(libs/util)
get_directory_property(aqsis_util_location DIRECTORY libs/util DEFINITION aqsis_util_location)
add_subdirectory(libs/riutil)
add_subdirectory(libs/ribparse)
add_subdirectory(libs/slcomp)
get_directory_property(aqsis_slcomp_location DIRECTORY libs/slcomp DEFINITION aqsis_slcomp_location)
add_subdirectory(libs/tex)
add_subdirectory(libs/shadervm)
add_subdirectory(libs/slxargs)
add_subdirectory(libs/ri2rib)
add_subdirectory(libs/rib2ri)
add_subdirectory(libs/core)

# Build executable tools
add_subdirectory(tools/aqsl)
add_subdirectory(tools/aqsltell)
add_subdirectory(tools/aqsis)
add_subdirectory(tools/miqser)
add_subdirectory(tools/teqser)
if(AQSIS_USE_FLTK AND AQSIS_FLUID_FOUND)
	add_subdirectory(tools/eqsl)
	add_subdirectory(tools/piqsl)
endif()

# Build displays
add_subdirectory(tools/displays)

# Build additional plugins
add_subdirectory(tools/procedurals/hairgen)
#add_subdirectory(tools/shadeops/sci_volumes)
add_subdirectory(tools/neqsus)

# Build shaders & install examples
add_subdirectory(shaders)
add_subdirectory(examples)

# Build docs
if(AQSIS_ENABLE_DEVDOCS)
	add_subdirectory(doc/doxygen)
endif()

# Packaging
add_subdirectory(distribution)

#-------------------------------------------------------------------------------
# Create aqsisrc
#--------------
get_directory_property(display_DISPLAYLIB DIRECTORY tools/displays DEFINITION file_display_name)
get_directory_property(d_exr_DISPLAYLIB DIRECTORY tools/displays DEFINITION exr_display_name)
get_directory_property(d_bmp_DISPLAYLIB DIRECTORY tools/displays DEFINITION bmp_display_name)
get_directory_property(d_xpm_DISPLAYLIB DIRECTORY tools/displays DEFINITION xpm_display_name)
get_directory_property(piqsl_DISPLAYLIB DIRECTORY tools/displays DEFINITION piqsl_display_name)
# Default search paths.
set(DEFAULT_SHADERPATH ${shader_search_path})
set(DEFAULT_ARCHIVEPATH "${CMAKE_INSTALL_PREFIX}")
set(DEFAULT_TEXTUREPATH "${CMAKE_INSTALL_PREFIX}")
set_with_path_prefix(DEFAULT_DISPLAYPATH "${PLUGINDIR}" "${CMAKE_INSTALL_PREFIX}")
set_with_path_prefix(DEFAULT_PROCEDURALPATH "${PLUGINDIR}" "${CMAKE_INSTALL_PREFIX}")
set(DEFAULT_RESOURCEPATH "${CMAKE_INSTALL_PREFIX}")
# Search paths which are settable from the cmake build.
set(SHADERPATH "${SHADERPATH}" CACHE STRING "Aqsis shader searchpath")
set(ARCHIVEPATH "${ARCHIVEPATH}" CACHE STRING "Aqsis archive searchpath")
set(TEXTUREPATH "${TEXTUREPATH}" CACHE STRING "Aqsis texture searchpath")
set(DISPLAYPATH "${DISPLAYPATH}" CACHE STRING "Aqsis display searchpath")
set(PROCEDURALPATH "${PROCEDURALPATH}" CACHE STRING "Aqsis procedural searchpath")
set(RESOURCEPATH "${RESOURCEPATH}" CACHE STRING "Aqsis resource searchpath")
set(aqsisrc_name ${PROJECT_BINARY_DIR}/aqsisrc)
configure_file(aqsisrc.in.cmake ${aqsisrc_name})
install(FILES ${aqsisrc_name} DESTINATION ${SYSCONFDIR} COMPONENT main)

=== distribution/CMakeLists.txt ===
# Set some variables used in configuring various packaging stuff.
SET(AQSIS_PROJECT_NAME "Aqsis Renderer")
SET(AQSIS_PROJECT_NAME_SHORT "Aqsis")
SET(AQSIS_PROJECT_NAME_BASIC "aqsis")
SET(AQSIS_PROJECT_VENDOR "Aqsis Team")
SET(AQSIS_PROJECT_COPYRIGHT "Copyright (C) 2009, ${AQSIS_PROJECT_VENDOR}.")
SET(AQSIS_PROJECT_COPYRIGHT_OTHER "The RenderMan(R) Interface Procedures and Protocol are Copyright 1988, 1989, 2000, 2005 Pixar. All Rights Reserved.")

if(WIN32)
	# There is a bug in NSI that does not handle full unix paths properly. Make
	# sure there is at least one set of four (4) backlasshes.
	set(CPACK_PACKAGE_FILE_NAME "${AQSIS_PROJECT_NAME_BASIC}-setup-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BUILD}")
	set(CPACK_PACKAGE_EXECUTABLES "eqsl;${AQSIS_PROJECT_NAME}")
	set(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/distribution/win\\\\header.bmp")
	set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "${AQSIS_PROJECT_NAME_SHORT} ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BUILD}")
	set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\eqsl.exe")
	set(CPACK_NSIS_DISPLAY_NAME "${AQSIS_PROJECT_NAME} ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BUILD}")
	set(CPACK_NSIS_HELP_LINK "http:\\\\\\\\community.aqsis.org")
	set(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.aqsis.org")
	set(CPACK_NSIS_CONTACT "packages@aqsis.org")
	set(CPACK_NSIS_MODIFY_PATH ON)
	set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
		!addincludedir \\\"${CMAKE_SOURCE_DIR}/distribution/win/nsis\\\"
		!include custom_install.nsi")
	set(CPACK_ALL_INSTALL_TYPES Full Minimal)
	set(CPACK_COMPONENT_MAIN_INSTALL_TYPES Full Minimal)
	set(CPACK_COMPONENT_DEVELOPMENT_INSTALL_TYPES Full)
	set(CPACK_COMPONENT_EXAMPLES_INSTALL_TYPES Full)
	set(CPACK_COMPONENT_SHADERS_INSTALL_TYPES Full)
	set(CPACK_COMPONENT_PLUGINS_INSTALL_TYPES Full)
	set(CPACK_GENERATOR "NSIS")
	set(CPACK_SOURCE_GENERATOR "ZIP")
	# Cusotm Windows NSIS installer
	#add_subdirectory(win/nsis)

elseif(APPLE)
	set(BUNDLEDIR "${CMAKE_BINARY_DIR}/bundle"
		CACHE STRING "Staging location for bundles (relative to CMAKE_BINARY_DIR)"
		)
	set(CPACK_PACKAGE_FILE_NAME
		"${AQSIS_PROJECT_NAME_SHORT}-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BUILD}-${CMAKE_SYSTEM_NAME}")
	#set(CPACK_PACKAGE_ICON "")
	set(CPACK_BUNDLE_NAME "${AQSIS_PROJECT_NAME_SHORT}")
	set(CPACK_BUNDLE_ICON "${BUNDLEDIR}/Aqsis.icns")
	set(CPACK_BUNDLE_PLIST "${BUNDLEDIR}/Info.plist")
	set(CPACK_BUNDLE_STARTUP_COMMAND "")
	set(CPACK_GENERATOR "Bundle")
	set(CPACK_SOURCE_GENERATOR "TGZ")
	# Custom OS X Bundle
	add_subdirectory(macosx/bundle)

elseif(UNIX)
	set(CPACK_SOURCE_PACKAGE_FILE_NAME
		"${AQSIS_PROJECT_NAME_BASIC}-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BUILD}")
	set(CPACK_GENERATOR "TGZ")
	set(CPACK_SOURCE_GENERATOR "TGZ")
	# Cusotm Linux RPM
	#add_subdirectory(linux/rpm)

endif()


#--------------------------------------------------
# Generic Packaging setup
include(InstallRequiredSystemLibraries)

set(CPACK_PACKAGE_NAME "${AQSIS_PROJECT_NAME_SHORT}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${AQSIS_PROJECT_NAME}")
set(CPACK_PACKAGE_VENDOR "${AQSIS_PROJECT_VENDOR}")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README")
set(CPACK_RESOURCE_FILE_WELCOME "${CMAKE_SOURCE_DIR}/README")
set(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${VERSION_BUILD}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "${AQSIS_PROJECT_NAME_SHORT}")

set(CPACK_COMPONENTS_ALL main examples shaders plugins development Unspecified)
set(CPACK_COMPONENT_MAIN_REQUIRED TRUE)
set(CPACK_COMPONENT_UNSPECIFIED_REQUIRED TRUE)
set(CPACK_COMPONENT_UNSPECIFIED_HIDDEN TRUE)
set(CPACK_COMPONENT_EXAMPLES_GROUP "content")
set(CPACK_COMPONENT_SHADERS_GROUP "content")
set(CPACK_COMPONENT_MAIN_DESCRIPTION
	"Rendering application and essential files only")
set(CPACK_COMPONENT_GROUP_CONTENT_DESCRIPTION
	"Examples and shader source files")
set(CPACK_COMPONENT_EXAMPLES_DESCRIPTION
	"Example files (.rib)")
set(CPACK_COMPONENT_SHADERS_DESCRIPTION
	"Generic shader source files (.sl)")
set(CPACK_COMPONENT_PLUGINS_DESCRIPTION
	"Plugins for external applications")
set(CPACK_COMPONENT_DEVELOPMENT_DESCRIPTION
	"Include and library files for software development")

set(CPACK_SOURCE_IGNORE_FILES
	".*/\\\\.git/"
	)

include(CPack)

=== examples/CMakeLists.txt ===
project(example_content)

#source_tree_relpath(examples_reldir)
#set(examples_install_dir ${share_install_dir}/${examples_reldir})
set(examples_install_dir ${EXAMPLESDIR})

if(WIN32)
	install(DIRECTORY features procedurals scenes
		DESTINATION ${examples_install_dir}
		COMPONENT examples
		# TODO: Refactor the blobby content examples to allow distribution.  For
		# now we exclude them with a pattern.
		PATTERN "features/blobby" EXCLUDE
		PATTERN "features/pointcloud" EXCLUDE
		PATTERN "*.sh" EXCLUDE)
else()
	install(DIRECTORY features procedurals scenes
		DESTINATION ${examples_install_dir}
		COMPONENT examples
		# TODO: Refactor the blobby content examples to allow distribution.  For
		# now we exclude them with a pattern.
		PATTERN "features/blobby" EXCLUDE
		PATTERN "features/pointcloud" EXCLUDE
		PATTERN "*.bat" EXCLUDE
		PATTERN "*.sh"
		PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
				GROUP_EXECUTE GROUP_READ
				WORLD_EXECUTE WORLD_READ)
endif()

=== shaders/CMakeLists.txt ===
project(shaders)

set(shader_dirs
	displacement
	imager
	light
	surface
	volume
)

# Make sure that all the binary directories into which the compiled shaders
# will be placed exist.
add_prefix(shader_dirs_abs "${CMAKE_CURRENT_BINARY_DIR}/" ${shader_dirs})
file(MAKE_DIRECTORY ${shader_dirs_abs})

# for visual studio IDE set the path correctly for custom commands
if(WIN32 AND MSVC_IDE)
	file(TO_NATIVE_PATH "${aqsis_util_location}" aqsis_util_path_windows)
	file(TO_NATIVE_PATH "${aqsis_slcomp_location}" aqsis_slcomp_path_windows)
	set(CMAKE_MSVCIDE_RUN_PATH "${CMAKE_MSVCIDE_RUN_PATH}" "${aqsis_util_path_windows}" "${aqsis_slcomp_path_windows}"
		CACHE STATIC "MSVC IDE Run path" FORCE)
endif()


set(compiled_shaders)
foreach(dir ${shader_dirs})
	file(GLOB shader_srcs "${dir}/*.sl")
	foreach(shader_name ${shader_srcs})
		get_filename_component(basename ${shader_name} NAME_WE)
		set(shader_output_name "${CMAKE_CURRENT_BINARY_DIR}/${dir}/${basename}.slx")
		list(APPEND compiled_shaders ${shader_output_name})
		# Add a command to compile the shader
		add_custom_command(
			OUTPUT ${shader_output_name}
			COMMAND aqsl -o ${shader_output_name}
				         -I ${CMAKE_CURRENT_SOURCE_DIR}/include ${shader_name}
			DEPENDS ${shader_name} aqsl
			COMMENT "Compiling shader ${shader_name}"
		)
	endforeach()
endforeach()

# Add a target which depends on all compiled shaders so that they'll be built
# prior to the install stage.
add_custom_target(all_shaders ALL DEPENDS ${compiled_shaders})

# Install all compiled and source shaders, and construct the installed shader
# search path.
#source_tree_relpath(shaders_reldir)
#set(shaders_install_dir ${share_install_dir}/${shaders_reldir})
set(shaders_install_dir ${SHADERDIR})
set_with_path_prefix(shaders_searchpath_dir "${SHADERDIR}" "${CMAKE_INSTALL_PREFIX}")
set(shader_search_path)
foreach(dir ${shader_dirs})
	install(
		DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${dir}"
		DESTINATION ${shaders_install_dir}
		COMPONENT shaders
	)
	install(
		DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${dir}"
		DESTINATION ${shaders_install_dir}
		COMPONENT main
	)
	set(shader_search_path
		"${shader_search_path}:${shaders_searchpath_dir}/${dir}")
endforeach()
set(shader_search_path ${shader_search_path} PARENT_SCOPE)

# Install the include directory too.
install(
	DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include"
	DESTINATION ${shaders_install_dir}
	COMPONENT shaders
)

=== doc/doxygen/CMakeLists.txt ===
project(doxygen_docs)

find_package(Doxygen)

if(DOXYGEN_EXECUTABLE)

	set(doxyfile_in  "${PROJECT_SOURCE_DIR}/Doxyfile.in.cmake")
	set(doxyfile_out "${PROJECT_BINARY_DIR}/Doxyfile")

	# Create the doxygen config file
	message(STATUS "Create ${doxyfile_out} from ${doxyfile_in}")
	configure_file(${doxyfile_in} ${doxyfile_out} @ONLY)

	# Setup the doc build target
	add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${doxyfile_out})

endif(DOXYGEN_EXECUTABLE)

=== libs/core/CMakeLists.txt ===
project(core)

# Check for boost thread.
if(NOT Boost_THREAD_FOUND)
	message(FATAL_ERROR "Aqsis core requires boost thread to build")
endif()

# Generate extra files here.  Extra stuff in this directory is...
add_subproject(api)
add_subproject(ddmanager)
add_subproject(geometry)
add_subproject(raytrace)
add_subproject(texturing_old)

include_subproject(rib2ri)

set(core_srcs
	attributes.cpp
	bound.cpp
	bucket.cpp
	bucketprocessor.cpp
	csgtree.cpp
	filters.cpp
	grid.cpp
	imagebuffer.cpp
	imagepixel.cpp
	imagers.cpp
	lights.cpp
	micropolygon.cpp
	mpdump.cpp
	multijitter.cpp
	occlusion.cpp
	optioncache.cpp
	options.cpp
	parameters.cpp
	renderer.cpp
	shaders.cpp
	stats.cpp
	threadscheduler.cpp
	transform.cpp
	${api_srcs}
	${ddmanager_srcs}
	${geometry_srcs}
	${raytrace_srcs}
	${texturing_old_srcs}
	${rib2ri_srcs}
)

set(core_hdrs
	attributes.h
	bilinear.h
	bound.h
	bucket.h
	bucketprocessor.h
	channelbuffer.h
	clippingvolume.h
	csgtree.h
	forwarddiff.h
	grid.h
	imagebuffer.h
	imagepixel.h
	imagers.h
	isampler.h
	lights.h
	micropolygon.h
	motion.h
	mpdump.h
	multijitter.h
	objectinstance.h
	occlusion.h
	optioncache.h
	options.h
	parameters.h
	plane.h
	renderer.h
	shaders.h
	stats.h
	threadscheduler.h
	transform.h
	${api_hdrs}
	${ddmanager_hdrs}
	${geometry_hdrs}
	${raytrace_hdrs}
	${texturing_old_hdrs}
	${rib2ri_hdrs}
)

source_group("Header Files" FILES ${core_hdrs})

include_directories(
	${PROJECT_SOURCE_DIR}  #< Needed so that files in subdirectories can find headers.
	${AQSIS_TIFF_INCLUDE_DIR})

# Create list of preprocessor definitions
set(defs AQSIS_RI_EXPORTS AQSIS_CORE_EXPORTS
	"AQSIS_MAIN_CONFIG_NAME=${AQSIS_MAIN_CONFIG_NAME}")
if(AQSIS_ENABLE_MPDUMP)
	list(APPEND defs ENABLE_MPDUMP)
endif()
if(AQSIS_USE_TIMERS)
	list(APPEND defs USE_TIMERS)
endif()
if(AQSIS_ENABLE_THREADING)
	list(APPEND defs ENABLE_THREADING)
endif()
if(DEFAULT_RC_PATH)
	list(APPEND defs "DEFAULT_RC_PATH=${DEFAULT_RC_PATH}")
endif()


# Add library & install
aqsis_add_library(aqsis_core ${core_srcs} ${core_hdrs}
	COMPILE_DEFINITIONS ${defs}
	LINK_LIBRARIES aqsis_math aqsis_ribparse aqsis_shadervm
		aqsis_tex aqsis_util aqsis_riutil
		${AQSIS_TIFF_LIBRARIES} ${Boost_THREAD_LIBRARY} ${CARBON_LIBRARY}
	DEPENDS ri_inl
)

aqsis_install_targets(aqsis_core)


#--------------------------------------------------
# Testing
set(core_test_srcs
	${api_test_srcs}
	occlusion_test.cpp
	bilinear_test.cpp
)

aqsis_add_tests(${core_test_srcs} LINK_LIBRARIES aqsis_core)

=== libs/math/CMakeLists.txt ===
project(math)

set(math_srcs
	cellnoise.cpp
	color.cpp
	lowdiscrep.cpp
	matrix.cpp
	noise.cpp
	noise1234.cpp
	random.cpp
	spline.cpp
)

aqsis_add_library(aqsis_math ${math_srcs} ${math_hdrs}
	COMPILE_DEFINITIONS AQSIS_MATH_EXPORTS
)


aqsis_install_targets(aqsis_math)

#--------------------------------------------------
# Testing
set(math_test_srcs
	cellnoise_test.cpp
	color_test.cpp
	math_test.cpp
	matrix2d_test.cpp
	matrix_test.cpp
	noise1234_test.cpp
	noise_test.cpp
	spline_test.cpp
	vector2d_test.cpp
	vector3d_test.cpp
	vector4d_test.cpp
)

aqsis_add_tests(${math_test_srcs} LINK_LIBRARIES aqsis_math)

=== libs/ri2rib/CMakeLists.txt ===
project(ri2rib)

set(ri2rib_srcs
	ascii.cpp
	binary.cpp
	context.cpp
	error.cpp
	output.cpp
	outstream.cpp
	plstore.cpp
	ri.cpp
	tokens.cpp
)

set(ri2rib_hdrs
	ascii.h
	binary.h
	context.h
	error.h
	options.h
	output.h
	outstream.h
	plstore.h
)
source_group("Header Files" FILES ${ri2rib_hdrs})

include_directories(${AQSIS_ZLIB_INCLUDE_DIR})

aqsis_add_library(aqsis_ri2rib ${ri2rib_srcs} ${ri2rib_hdrs}
	COMPILE_DEFINITIONS AQSIS_RI_EXPORTS
	LINK_LIBRARIES aqsis_riutil ${AQSIS_ZLIB_LIBRARIES}
	DEPENDS ri_inl
)

aqsis_install_targets(aqsis_ri2rib)

=== libs/rib2ri/CMakeLists.txt ===
project(rib2ri)

include(project.cmake)

set(rib2ri_test_srcs
	ribrequesthandler_test.cpp
	# parser_speed_test.cpp
)

set(linklibs aqsis_ribparse aqsis_util)

aqsis_add_tests(${rib2ri_test_srcs}
	LINK_LIBRARIES ${linklibs}
	EXTRASOURCE ${rib2ri_srcs} ${rib2ri_hdrs}
	COMPILE_DEFINITIONS AQSIS_RI_EXPORTS
)

# The following is a bit of a hack, but it doesn't fit within the scope of
# aqsis_add_tests.
if(aqsis_enable_testing)
	# Speed test for parser and request handler
	add_executable(parser_speed_test parser_speed_test.cpp ${rib2ri_srcs} ${rib2ri_hdrs})
	target_link_libraries(parser_speed_test ${linklibs})
	# Set the exports necessary to avoid incorrect linkage errors.
	set_target_properties(parser_speed_test PROPERTIES COMPILE_DEFINITIONS AQSIS_RI_EXPORTS)
endif()

=== libs/ribparse/CMakeLists.txt ===
project(ribparse)

# Check for boost iostreams.
if(NOT Boost_IOSTREAMS_FOUND)
	message(FATAL_ERROR "Aqsis ribparse requires boost iostreams to build")
endif()

set(ribparse_srcs
	ribinputbuffer.cpp
	riblexer.cpp
	ribparser.cpp
)

set(ribparse_hdrs
	ribinputbuffer.h
	riblexer.h
	ribparser_impl.h
	ribtoken.h
)
source_group("Header Files" FILES ${ribparse_hdrs})

aqsis_add_library(aqsis_ribparse ${ribparse_srcs} ${ribparse_hdrs}
	COMPILE_DEFINITIONS AQSIS_RIBPARSER_EXPORTS USE_GZIPPED_RIB
	LINK_LIBRARIES aqsis_riutil ${Boost_IOSTREAMS_LIBRARY}
)

aqsis_install_targets(aqsis_ribparse)

#--------------------------------------------------
# Testing
set(ribparse_test_srcs
	ribinputbuffer_test.cpp
	riblexer_test.cpp
	ribparser_test.cpp
)

aqsis_add_tests(${ribparse_test_srcs} LINK_LIBRARIES aqsis_ribparse)

=== libs/riutil/CMakeLists.txt ===
project(riutil)

set(riutil_srcs
	primvartoken.cpp
	riparamlist.cpp
	tokendictionary.cpp
)

aqsis_add_library(aqsis_riutil ${riutil_srcs} ${riutil_hdrs}
	COMPILE_DEFINITIONS AQSIS_RIUTIL_EXPORTS
	LINK_LIBRARIES aqsis_util
)

aqsis_install_targets(aqsis_riutil)


#--------------------------------------------------
# Testing
set(riutil_test_srcs
	primvartoken_test.cpp
)
aqsis_add_tests(${riutil_test_srcs} LINK_LIBRARIES aqsis_riutil)

=== libs/shadervm/CMakeLists.txt ===
project(shadervm)

# Check for boost regex.
if(NOT Boost_REGEX_FOUND)
	message(FATAL_ERROR "Aqsis shadervm requires boost regex to build")
endif()

set(shadervm_srcs
	dsoshadeops.cpp
	shaderstack.cpp
	shadervm.cpp
	shadervm1.cpp
	shadervm2.cpp
)

set(shadervm_hdrs
	dsoshadeops.h
	idsoshadeops.h
	shadeopmacros.h
	shaderstack.h
	shadervariable.h
	shadervm.h
	shadervm_common.h
)
source_group("Header Files" FILES ${shadervm_hdrs})

add_subproject(shaderexecenv)

aqsis_add_library(aqsis_shadervm ${shadervm_srcs} ${shadervm_hdrs}
	${shaderexecenv_srcs} ${shaderexecenv_hdrs}
	COMPILE_DEFINITIONS AQSIS_SHADERVM_EXPORTS
	LINK_LIBRARIES aqsis_math aqsis_util aqsis_tex ${Boost_REGEX_LIBRARY}
)

aqsis_install_targets(aqsis_shadervm)

=== debian/changelog ===
aqsis (1.6.0-9) unstable; urgency=low

  * Switch to debhelper compat level v9
  * Enable some extra compiling options and hardening flags

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Tue, 20 Dec 2011 18:41:47 +0000

aqsis (1.6.0-8) unstable; urgency=low

  * Remove the use of special "CXXFLAGS" in debian/rules, use default
    ones
  * Removed Vcs-Hg and Vcs-Browser in "control" file, they point to
    upstream and not the Debian packaging
  * Quell lintian issues:
    - unneeded-build-dep-on-quilt: remove from Build-Depends

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sat, 22 Oct 2011 21:32:20 +0100

aqsis (1.6.0-7) unstable; urgency=low

  * Build-Depends on libjpeg-dev instead of libjpeg62-dev (Closes: #633687)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Thu, 14 Jul 2011 01:55:06 +0200

aqsis (1.6.0-6) unstable; urgency=low

  * Changed debhelper compat to level 8 (level 7 before), no changes needed
  * debhelper compat level 8 generates symbols files for shared libraries,
    quells lintian warning "no-symbols-control-file"
  * Change Maintainer to myself, I've been the only effective maintainer since
    2007, for more than a year now

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 08 Jul 2011 16:56:01 +0200

aqsis (1.6.0-5) unstable; urgency=low

  * Rebuild for transition to tinyxml 2.6.2 (Closes: #628117)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 27 May 2011 22:54:41 +0200

aqsis (1.6.0-4) unstable; urgency=low

  * Bump Standards-Version to 3.9.2 (no changes needed)
  * Include patch to avoid FTBFS with boost 1.46 (Closes: #624504)
  * Include patch to avoid FTBFS with missing NULL
  * Adding Replace and Breaks for aqsis-examples package on old aqsis-data
    package, to avoid having the old package hanging around
  * Simplifying a lot debian/rules file by leveraging debhelper capabilities,
    only acting when deviating from auto behaviour

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 27 May 2011 21:50:00 +0200

aqsis (1.6.0-3) unstable; urgency=low

  * Bumped Standards-Version to 3.9.1 (no changes needed)
  * Add DM-Upload-Allowed: yes
  * Update versions of some dependencies (flex, boost) so they match the
    versions currently in testing (to avoid using software which is too old and
    may have bugs)
  * Quell lintin warning: package-contains-empty-directory
    "usr/share/aqsis/plugins/"

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 15 Aug 2010 00:15:28 +0200

aqsis (1.6.0-2) unstable; urgency=low

  * Put myself in the Uploaders field
  * Bump Standards-Version to 3.9.0 (no changes needed)
  * Disable RPATH in building system (lintian: binary-or-shlib-defines-rpath)
  * Using Breaks instead of Conflicts (lintian: conflicts-with-version)
  * Remove houdini script, not interesting for Debian (it's intended as plugin
    for 3rd party proprietary software, to use Aqsis as renderer), and also has
    poor licensing terms (not well explained, not for all files, etc).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Tue, 06 Jul 2010 20:59:34 +0200

aqsis (1.6.0-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * For smooth upgrading in Debian and possibly derived distributions, libraries
    (libaqsis1 and libaqsis-dev) package Conflict and Replace "aqsis-libs" and
    also "aqsis-libs2ca" (which is how it was named in Debian), and restricts to
    versions (<< 1.6.0) just in case.
  * Document better 'copyright' file with additions of third party software
    shipped (one of which, tinyxml, is not used -- we instead depend on and
    build against the package that we already have in Debian).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Tue, 29 Jun 2010 16:52:15 +0200

aqsis (1.6.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release (Closes: #515065, #568270).
  * Updated descriptions, renamed packages from 'aqsis-libs*' to
    'libaqsis*', created a new -examples package
  * Updated man pages with 'help2man -N --no-discard-stderr"
  * Changed debhelper compat to level 7 (level 5 before)
  * Added 'watch' file
  * Added 'source/format', with '3.0 (quilt)'
  * Bump Standards-Version to 3.8.4
  * Removed patches:
    - "01_gcc_4.3_fixes.patch" and "02_gcc_4.4_fixes.patch", now
       builds with default gcc version
    - "03_env_clone.patch", doesn't use scons for building now

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Tue, 22 Jun 2010 03:22:09 +0200

aqsis (1.2.0-2.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS with GCC 4.4 (missing #include), (Closes: #504858).
    Thanks to Martin Michlmayr who reported the issue and provided a
    patch (added 02_gcc_4.4_fixes.patch). 
  * Use env.Clone instead of env.Copy in various SConscript files
    (added 03_env_clone.patch) (Closes: #549806, #564207)

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 31 Jan 2010 17:47:00 +0100

aqsis (1.2.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * fix ftbfs by including string.h in various sources (closes: #470971).
  * build against libopenexr6 (closes: #476739).
  * apply Ubuntu patch to debian/aqsis-libsc2a.install to fix
    missing libjpg2tif.so.1 problem (closes: #473151).

 -- Colin Tuckley <colint@debian.org>  Tue, 20 May 2008 14:37:25 +0100

aqsis (1.2.0-2) unstable; urgency=low

  * Added support for quilt in debian/control and debian/rules.
  * debian/control, debian/rules: Added support for quilt.
  * Added 01_gcc_4.3_fixes.patch for fixing build problems with upcoming GCC
    release.  Thanks, Martin Michlmayr (closes: #417108).

 -- David Martínez Moreno <ender@debian.org>  Wed, 30 May 2007 12:05:56 +0200

aqsis (1.2.0-1) unstable; urgency=low

  * New maintainer (closes: #368070).
  * New upstream release.  Main changes are:
    - Various small changes to support building for x86_64 systems.


=== debian/control ===
Source: aqsis
Section: graphics
Priority: optional
Maintainer: Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>
Uploaders: David Martínez Moreno <ender@debian.org>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8.9.0~), cmake (>= 2.6.3), flex (>= 2.5.35), bison (>= 1.35), libtiff4-dev, libjpeg-dev, libopenexr-dev, zlib1g-dev, libboost-filesystem-dev (>= 1.42), libboost-iostreams-dev (>= 1.42), libboost-wave-dev (>= 1.42), libboost-regex-dev (>= 1.42), libboost-serialization-dev (>> 1.42), libboost-test-dev (>= 1.42), libboost-thread-dev (>= 1.42), libfltk1.1-dev, fluid, xsltproc, libtinyxml-dev (>= 2.5)
Standards-Version: 3.9.2
Homepage: http://www.aqsis.org/


Package: aqsis
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libaqsis1 (= ${binary:Version})
Suggests: aqsis-examples (= ${binary:Version})
Description: 3D rendering solution adhering to the RenderMan(R) standard, binaries
 Aqsis is a high quality, photorealistic, 3D rendering solution. It complies
 with the RenderMan(R) interface standard defined by Pixar.
 .
 The RenderMan(R) standard has been used in film and television visual effects
 since it's introduction in 1989. Pixar has used their own implementation for
 all of their award winning CG features, and provided their implementation for
 use in the visual effects of most major blockbuster films over the last 2
 decades. The Aqsis project offers a way for individuals and organisations alike
 to gain experience with the RenderMan(R) interface without the cost of
 commercial software licenses.
 .
 This package contains the Aqsis binaries (command line rendering tool, a tool
 for compiling shaders in the RSL language and a tool for preparing textures for
 optimal use).

Package: aqsis-examples
Architecture: all
Depends: ${misc:Depends}
Suggests: aqsis, python
Replaces: aqsis-data (<< 1.6.0)
Breaks: aqsis-data (<< 1.6.0)
Description: 3D rendering solution adhering to the RenderMan(R) standard, examples
 Aqsis is a high quality, photorealistic, 3D rendering solution. It complies
 with the RenderMan(R) interface standard defined by Pixar.
 .
 The RenderMan(R) standard has been used in film and television visual effects
 since it's introduction in 1989. Pixar has used their own implementation for
 all of their award winning CG features, and provided their implementation for
 use in the visual effects of most major blockbuster films over the last 2
 decades. The Aqsis project offers a way for individuals and organisations alike
 to gain experience with the RenderMan(R) interface without the cost of
 commercial software licenses.
 .
 This package contains examples like scenes, procedurals and shaders.

Package: libaqsis1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: aqsis-libs (<< 1.6.0), aqsis-libsc2a (<< 1.6.0)
Breaks: aqsis-libs (<< 1.6.0), aqsis-libsc2a (<< 1.6.0), 
Description: 3D rendering solution adhering to the RenderMan(R) standard, shared libs
 Aqsis is a high quality, photorealistic, 3D rendering solution. It complies
 with the RenderMan(R) interface standard defined by Pixar.
 .
 The RenderMan(R) standard has been used in film and television visual effects
 since it's introduction in 1989. Pixar has used their own implementation for
 all of their award winning CG features, and provided their implementation for
 use in the visual effects of most major blockbuster films over the last 2
 decades. The Aqsis project offers a way for individuals and organisations alike
 to gain experience with the RenderMan(R) interface without the cost of
 commercial software licenses.
 .
 This package contains the Aqsis shared libraries.

Package: libaqsis-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libaqsis1 (= ${binary:Version})
Replaces: aqsis-libs-dev (<< 1.6.0)
Breaks: aqsis-libs-dev (<< 1.6.0)
Description: 3D rendering solution adhering to the RenderMan(R) standard, development files
 Aqsis is a high quality, photorealistic, 3D rendering solution. It complies
 with the RenderMan(R) interface standard defined by Pixar.
 .
 The RenderMan(R) standard has been used in film and television visual effects
 since it's introduction in 1989. Pixar has used their own implementation for
 all of their award winning CG features, and provided their implementation for
 use in the visual effects of most major blockbuster films over the last 2
 decades. The Aqsis project offers a way for individuals and organisations alike
 to gain experience with the RenderMan(R) interface without the cost of
 commercial software licenses.
 .
 This package contains the Aqsis development files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow
export DEB_CFLAGS_MAINT_APPEND := -pipe -Wall
export DEB_CXXFLAGS_MAINT_APPEND := -pipe -Wall
export DEB_LDFLAGS_MAINT_APPEND := -Wl,-Bsymbolic -Wl,--as-needed


AQSIS_CHANGELOG = release-notes/1.6/summary-1.6.0.txt


%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DSYSCONFDIR=/etc/aqsis \
		-DAQSIS_USE_EXTERNAL_TINYXML:BOOL=ON \
		-DAQSIS_USE_PDIFF:BOOL=OFF \
		-DAQSIS_USE_RPATH:BOOL=OFF

override_dh_auto_build:
	dh_auto_build --parallel

override_dh_auto_install:
	dh_auto_install

#	Remove houdini script, not interesting for Debian (it's intended as
#	plugin for 3rd party proprietary software, to use Aqsis as renderer),
#	and also has poor licensing terms (not well explained, not for all
#	files, etc).
	rm -fr debian/tmp/usr/share/aqsis/plugins/houdini

#	Remove empty directory (valid until/unless there are more plugins than
#	houdini), otherwise dh_install fails with --list-missing
	rmdir debian/tmp/usr/share/aqsis/plugins

#	Add exec permissions to several example scripts
	find debian/tmp/usr/ \( -name \*.sh -o -name \*.py \) -exec chmod a+x {} \;

override_dh_installchangelogs:
	dh_installchangelogs $(AQSIS_CHANGELOG)
